︠c3c4077b-a8d2-43b3-acf2-62b0ad94adb6︠
base_ring=QQbar
R.<a,b,c,d,e,f,g,h,i,j>=PolynomialRing(base_ring)
T.<x>=LaurentSeriesRing(R)
T
︡6fab524b-610d-4e4d-9d18-aeb9b5ea72d9︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}Laurent Series Ring in x over Multivariate Polynomial Ring in a, b, c, d, e, f, g, h, i, j over Algebraic Field</span>"}︡
︠fc949b6e-07b8-41f1-b622-7e2a785ec980︠
def powseries_root_1(f,d):
    if f[0]!=1:
        raise TypeError,"The constant term must be 1"
    elif f==1:
        return 1+O(x^(f.prec()))
    else:
        pow=sum(f.base_ring()(binomial(1/d,i))*(f-1)^i for i in range(f.prec()))
        return pow
                
def powseries_root(f,d):
    return (f[0].coefficients())[0]^(1/d)*powseries_root_1(f/f[0],d)

def powseries_reverse(f):
    if f[0]!=0 or f[1]==0:
        raise TypeError,"The power series must have order 1"
    else:
        d=f.prec()
        g=x/f[1]+O(x^d)
        for i in [2..d-1]:
            h=f.subs(x=g)
            g=g-(h[i]/f[1].coefficients()[0])*x^i
    return g

def local_fourier(f):
    d=f.degree()
    df=f.derivative()
    df_rev=x^(d-1)*df(1/x)+O(x^d)
    df_rev_root=powseries_root(df_rev,d-1)
    dg_rev=x/powseries_reverse(x/df_rev_root)
    t=x*dg_rev.subs(x=1/x)
    dg=(d-1)*t*x^(d-2)
    g=dg.integral()
    return g
︡623b6239-02ce-46b2-bdda-5c9b219dc9b1︡︡
︠38675c73-bd95-4490-911c-4f51e8a864bd︠
local_fourier(x^5/5+a*x^4+b*x^3+c*x^2+d*x+e)
︡1cd6210e-63ae-4a3c-b079-87c226566a8e︡{"stdout": "(15/2*a^4 + (-15/2)*a^2*b + 9/8*b^2 + 2*a*c - d)*x + ((-4)*a^3 + 3*a*b - c)*x^2 + (2*a^2 - b)*x^3 - a*x^4 + 4/5*x^5"}︡
︠2e047c6e-1b53-4786-b901-96a675bbadc4︠
local_fourier(x^5+5*a*x^4+5*b*x^3+5*c*x^2+5*d*x+5*e)
︡e5e4af5d-c62e-47e7-9c32-cbab84b76251︡{"stdout": "(25.07776143661583?*a^4 + (-25.07776143661583?)*a^2*b + 3.761664215492374?*b^2 + 6.687403049764221?*a*c + (-3.343701524882111?)*d)*x + ((-8.94427190999916?)*a^3 + 6.708203932499369?*a*b + (-2.236067977499790?)*c)*x^2 + (2.990697562442442?*a^2 + (-1.495348781221221?)*b)*x^3 - a*x^4 + 0.5349922439811376?*x^5"}︡
︠1b5a60e7-db17-4190-9897-d069b6b1eb52︠
local_fourier(x^6/6+a*x^5+b*x^4+c*x^3+d*x^2+e*x)
︡7c1715b9-462d-47a1-a8f3-66a230d31bab︡{"stdout": "((-44)*a^5 + 44*a^3*b + (-48/5)*a*b^2 + (-9)*a^2*c + 12/5*b*c + 2*a*d - e)*x + (35/2*a^4 + (-14)*a^2*b + 8/5*b^2 + 3*a*c - d)*x^2 + ((-20/3)*a^3 + 4*a*b - c)*x^3 + (5/2*a^2 - b)*x^4 - a*x^5 + 5/6*x^6"}︡
︠d245c904-8612-4847-b377-8746d0e4fba2︠
local_fourier(x^5/5+a*x^4+2*b*x^3+3*c*x^2+4*d*x)
︡cc2d2c1c-7036-4bd3-9b5c-4a1234f0e6f8︡{"stdout": "(15/2*a^4 + (-15)*a^2*b + 9/2*b^2 + 6*a*c + (-4)*d)*x + ((-4)*a^3 + 6*a*b + (-3)*c)*x^2 + (2*a^2 + (-2)*b)*x^3 - a*x^4 + 4/5*x^5"}︡
︠5272d137-bbd6-423d-9cb4-7467ed4ad474︠
3perm=permutations([a,b,c,d])
combi=sum((j[0]+I*j[1]-j[2]-I*j[3])^4 for j in perm).factor()
combi
︡b7c2a119-23f5-4342-8ee4-2024196f5c0e︡{"stdout": "8*(3*d^4 - 4*c*d^3 - 4*b*d^3 - 4*a*d^3 - 6*c^2*d^2 + 12*b*c*d^2 + 12*a*c*d^2 - 6*b^2*d^2 + 12*a*b*d^2 - 6*a^2*d^2 - 4*c^3*d + 12*b*c^2*d + 12*a*c^2*d + 12*b^2*c*d - 72*a*b*c*d + 12*a^2*c*d - 4*b^3*d + 12*a*b^2*d + 12*a^2*b*d - 4*a^3*d + 3*c^4 - 4*b*c^3 - 4*a*c^3 - 6*b^2*c^2 + 12*a*b*c^2 - 6*a^2*c^2 - 4*b^3*c + 12*a*b^2*c + 12*a^2*b*c - 4*a^3*c + 3*b^4 - 4*a*b^3 - 6*a^2*b^2 - 4*a^3*b + 3*a^4)"}︡
︠95bbb8e0-401a-4898-b04c-413cbf61d13b︠
(8*512*pf4.coefficients()[0]-5*combi).factor()
︡42d162bd-eb25-4ff8-ae47-2e220ff093eb︡{"stdout": "192*(c^2*d^2 - b*c*d^2 - a*c*d^2 + b^2*d^2 - a*b*d^2 + a^2*d^2 - b*c^2*d - a*c^2*d - b^2*c*d + 6*a*b*c*d - a^2*c*d - a*b^2*d - a^2*b*d + b^2*c^2 - a*b*c^2 + a^2*c^2 - a*b^2*c - a^2*b*c + a^2*b^2)"}︡
︠d018dd29-d0ed-4401-a26c-593866a06fdd︠
_.expand()
︡4753a409-3034-42c3-9711-4832e117ad6b︡{"stdout": "-768*c^2*d^2 + 768*b*c*d^2 + 768*a*c*d^2 - 768*b^2*d^2 + 768*a*b*d^2 - 768*a^2*d^2 + 768*b*c^2*d + 768*a*c^2*d + 768*b^2*c*d - 4608*a*b*c*d + 768*a^2*c*d + 768*a*b^2*d + 768*a^2*b*d - 768*b^2*c^2 + 768*a*b*c^2 - 768*a^2*c^2 + 768*a*b^2*c + 768*a^2*b*c - 768*a^2*b^2"}︡
︠960255ea-9cd7-4c5b-89f2-2c40805f024f︠
_.factor()
︡1d2666c3-9986-4a72-91fd-bd51b1571f7a︡{"stdout": "-768*(c^2*d^2 - b*c*d^2 - a*c*d^2 + b^2*d^2 - a*b*d^2 + a^2*d^2 - b*c^2*d - a*c^2*d - b^2*c*d + 6*a*b*c*d - a^2*c*d - a*b^2*d - a^2*b*d + b^2*c^2 - a*b*c^2 + a^2*c^2 - a*b^2*c - a^2*b*c + a^2*b^2)"}︡
